# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['ActivateCentralizedPolicyArgs', 'ActivateCentralizedPolicy']

@pulumi.input_type
class ActivateCentralizedPolicyArgs:
    def __init__(__self__, *,
                 version: Optional[pulumi.Input[int]] = None):
        """
        The set of arguments for constructing a ActivateCentralizedPolicy resource.
        :param pulumi.Input[int] version: The version of the centralized policy
        """
        if version is not None:
            pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter
    def version(self) -> Optional[pulumi.Input[int]]:
        """
        The version of the centralized policy
        """
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "version", value)


@pulumi.input_type
class _ActivateCentralizedPolicyState:
    def __init__(__self__, *,
                 version: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering ActivateCentralizedPolicy resources.
        :param pulumi.Input[int] version: The version of the centralized policy
        """
        if version is not None:
            pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter
    def version(self) -> Optional[pulumi.Input[int]]:
        """
        The version of the centralized policy
        """
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "version", value)


class ActivateCentralizedPolicy(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 version: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        This resource can activate a centralized policy.

        ## Import

        ```sh
        $ pulumi import sdwan:index/activateCentralizedPolicy:ActivateCentralizedPolicy example "f6b2c44c-693c-4763-b010-895aa3d236bd"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] version: The version of the centralized policy
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[ActivateCentralizedPolicyArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource can activate a centralized policy.

        ## Import

        ```sh
        $ pulumi import sdwan:index/activateCentralizedPolicy:ActivateCentralizedPolicy example "f6b2c44c-693c-4763-b010-895aa3d236bd"
        ```

        :param str resource_name: The name of the resource.
        :param ActivateCentralizedPolicyArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ActivateCentralizedPolicyArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 version: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ActivateCentralizedPolicyArgs.__new__(ActivateCentralizedPolicyArgs)

            __props__.__dict__["version"] = version
        super(ActivateCentralizedPolicy, __self__).__init__(
            'sdwan:index/activateCentralizedPolicy:ActivateCentralizedPolicy',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            version: Optional[pulumi.Input[int]] = None) -> 'ActivateCentralizedPolicy':
        """
        Get an existing ActivateCentralizedPolicy resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] version: The version of the centralized policy
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ActivateCentralizedPolicyState.__new__(_ActivateCentralizedPolicyState)

        __props__.__dict__["version"] = version
        return ActivateCentralizedPolicy(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def version(self) -> pulumi.Output[Optional[int]]:
        """
        The version of the centralized policy
        """
        return pulumi.get(self, "version")

