# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['ApplicationPriorityQosPolicyArgs', 'ApplicationPriorityQosPolicy']

@pulumi.input_type
class ApplicationPriorityQosPolicyArgs:
    def __init__(__self__, *,
                 feature_profile_id: pulumi.Input[str],
                 description: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 qos_schedulers: Optional[pulumi.Input[Sequence[pulumi.Input['ApplicationPriorityQosPolicyQosSchedulerArgs']]]] = None,
                 target_interface_variable: Optional[pulumi.Input[str]] = None,
                 target_interfaces: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        The set of arguments for constructing a ApplicationPriorityQosPolicy resource.
        :param pulumi.Input[str] feature_profile_id: Feature Profile ID
        :param pulumi.Input[str] description: The description of the Policy
        :param pulumi.Input[str] name: The name of the Policy
        :param pulumi.Input[Sequence[pulumi.Input['ApplicationPriorityQosPolicyQosSchedulerArgs']]] qos_schedulers: qosSchedulers
        :param pulumi.Input[str] target_interface_variable: Variable name
        :param pulumi.Input[Sequence[pulumi.Input[str]]] target_interfaces: interfaces
        """
        pulumi.set(__self__, "feature_profile_id", feature_profile_id)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if qos_schedulers is not None:
            pulumi.set(__self__, "qos_schedulers", qos_schedulers)
        if target_interface_variable is not None:
            pulumi.set(__self__, "target_interface_variable", target_interface_variable)
        if target_interfaces is not None:
            pulumi.set(__self__, "target_interfaces", target_interfaces)

    @property
    @pulumi.getter(name="featureProfileId")
    def feature_profile_id(self) -> pulumi.Input[str]:
        """
        Feature Profile ID
        """
        return pulumi.get(self, "feature_profile_id")

    @feature_profile_id.setter
    def feature_profile_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "feature_profile_id", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        The description of the Policy
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the Policy
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="qosSchedulers")
    def qos_schedulers(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ApplicationPriorityQosPolicyQosSchedulerArgs']]]]:
        """
        qosSchedulers
        """
        return pulumi.get(self, "qos_schedulers")

    @qos_schedulers.setter
    def qos_schedulers(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ApplicationPriorityQosPolicyQosSchedulerArgs']]]]):
        pulumi.set(self, "qos_schedulers", value)

    @property
    @pulumi.getter(name="targetInterfaceVariable")
    def target_interface_variable(self) -> Optional[pulumi.Input[str]]:
        """
        Variable name
        """
        return pulumi.get(self, "target_interface_variable")

    @target_interface_variable.setter
    def target_interface_variable(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "target_interface_variable", value)

    @property
    @pulumi.getter(name="targetInterfaces")
    def target_interfaces(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        interfaces
        """
        return pulumi.get(self, "target_interfaces")

    @target_interfaces.setter
    def target_interfaces(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "target_interfaces", value)


@pulumi.input_type
class _ApplicationPriorityQosPolicyState:
    def __init__(__self__, *,
                 description: Optional[pulumi.Input[str]] = None,
                 feature_profile_id: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 qos_schedulers: Optional[pulumi.Input[Sequence[pulumi.Input['ApplicationPriorityQosPolicyQosSchedulerArgs']]]] = None,
                 target_interface_variable: Optional[pulumi.Input[str]] = None,
                 target_interfaces: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 version: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering ApplicationPriorityQosPolicy resources.
        :param pulumi.Input[str] description: The description of the Policy
        :param pulumi.Input[str] feature_profile_id: Feature Profile ID
        :param pulumi.Input[str] name: The name of the Policy
        :param pulumi.Input[Sequence[pulumi.Input['ApplicationPriorityQosPolicyQosSchedulerArgs']]] qos_schedulers: qosSchedulers
        :param pulumi.Input[str] target_interface_variable: Variable name
        :param pulumi.Input[Sequence[pulumi.Input[str]]] target_interfaces: interfaces
        :param pulumi.Input[int] version: The version of the Policy
        """
        if description is not None:
            pulumi.set(__self__, "description", description)
        if feature_profile_id is not None:
            pulumi.set(__self__, "feature_profile_id", feature_profile_id)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if qos_schedulers is not None:
            pulumi.set(__self__, "qos_schedulers", qos_schedulers)
        if target_interface_variable is not None:
            pulumi.set(__self__, "target_interface_variable", target_interface_variable)
        if target_interfaces is not None:
            pulumi.set(__self__, "target_interfaces", target_interfaces)
        if version is not None:
            pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        The description of the Policy
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="featureProfileId")
    def feature_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        Feature Profile ID
        """
        return pulumi.get(self, "feature_profile_id")

    @feature_profile_id.setter
    def feature_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "feature_profile_id", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the Policy
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="qosSchedulers")
    def qos_schedulers(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ApplicationPriorityQosPolicyQosSchedulerArgs']]]]:
        """
        qosSchedulers
        """
        return pulumi.get(self, "qos_schedulers")

    @qos_schedulers.setter
    def qos_schedulers(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ApplicationPriorityQosPolicyQosSchedulerArgs']]]]):
        pulumi.set(self, "qos_schedulers", value)

    @property
    @pulumi.getter(name="targetInterfaceVariable")
    def target_interface_variable(self) -> Optional[pulumi.Input[str]]:
        """
        Variable name
        """
        return pulumi.get(self, "target_interface_variable")

    @target_interface_variable.setter
    def target_interface_variable(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "target_interface_variable", value)

    @property
    @pulumi.getter(name="targetInterfaces")
    def target_interfaces(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        interfaces
        """
        return pulumi.get(self, "target_interfaces")

    @target_interfaces.setter
    def target_interfaces(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "target_interfaces", value)

    @property
    @pulumi.getter
    def version(self) -> Optional[pulumi.Input[int]]:
        """
        The version of the Policy
        """
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "version", value)


class ApplicationPriorityQosPolicy(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 feature_profile_id: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 qos_schedulers: Optional[pulumi.Input[Sequence[pulumi.Input[Union['ApplicationPriorityQosPolicyQosSchedulerArgs', 'ApplicationPriorityQosPolicyQosSchedulerArgsDict']]]]] = None,
                 target_interface_variable: Optional[pulumi.Input[str]] = None,
                 target_interfaces: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 __props__=None):
        """
        This resource can manage a Application Priority QoS Policy.
          - Minimum SD-WAN Manager version: `20.12.0`

        ## Import

        Expected import identifier with the format: "application_priority_qos_policy_id,feature_profile_id"

        ```sh
        $ pulumi import sdwan:index/applicationPriorityQosPolicy:ApplicationPriorityQosPolicy example "f6b2c44c-693c-4763-b010-895aa3d236bd,f6dd22c8-0b4f-496c-9a0b-6813d1f8b8ac"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: The description of the Policy
        :param pulumi.Input[str] feature_profile_id: Feature Profile ID
        :param pulumi.Input[str] name: The name of the Policy
        :param pulumi.Input[Sequence[pulumi.Input[Union['ApplicationPriorityQosPolicyQosSchedulerArgs', 'ApplicationPriorityQosPolicyQosSchedulerArgsDict']]]] qos_schedulers: qosSchedulers
        :param pulumi.Input[str] target_interface_variable: Variable name
        :param pulumi.Input[Sequence[pulumi.Input[str]]] target_interfaces: interfaces
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ApplicationPriorityQosPolicyArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource can manage a Application Priority QoS Policy.
          - Minimum SD-WAN Manager version: `20.12.0`

        ## Import

        Expected import identifier with the format: "application_priority_qos_policy_id,feature_profile_id"

        ```sh
        $ pulumi import sdwan:index/applicationPriorityQosPolicy:ApplicationPriorityQosPolicy example "f6b2c44c-693c-4763-b010-895aa3d236bd,f6dd22c8-0b4f-496c-9a0b-6813d1f8b8ac"
        ```

        :param str resource_name: The name of the resource.
        :param ApplicationPriorityQosPolicyArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ApplicationPriorityQosPolicyArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 feature_profile_id: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 qos_schedulers: Optional[pulumi.Input[Sequence[pulumi.Input[Union['ApplicationPriorityQosPolicyQosSchedulerArgs', 'ApplicationPriorityQosPolicyQosSchedulerArgsDict']]]]] = None,
                 target_interface_variable: Optional[pulumi.Input[str]] = None,
                 target_interfaces: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ApplicationPriorityQosPolicyArgs.__new__(ApplicationPriorityQosPolicyArgs)

            __props__.__dict__["description"] = description
            if feature_profile_id is None and not opts.urn:
                raise TypeError("Missing required property 'feature_profile_id'")
            __props__.__dict__["feature_profile_id"] = feature_profile_id
            __props__.__dict__["name"] = name
            __props__.__dict__["qos_schedulers"] = qos_schedulers
            __props__.__dict__["target_interface_variable"] = target_interface_variable
            __props__.__dict__["target_interfaces"] = target_interfaces
            __props__.__dict__["version"] = None
        super(ApplicationPriorityQosPolicy, __self__).__init__(
            'sdwan:index/applicationPriorityQosPolicy:ApplicationPriorityQosPolicy',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            description: Optional[pulumi.Input[str]] = None,
            feature_profile_id: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None,
            qos_schedulers: Optional[pulumi.Input[Sequence[pulumi.Input[Union['ApplicationPriorityQosPolicyQosSchedulerArgs', 'ApplicationPriorityQosPolicyQosSchedulerArgsDict']]]]] = None,
            target_interface_variable: Optional[pulumi.Input[str]] = None,
            target_interfaces: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            version: Optional[pulumi.Input[int]] = None) -> 'ApplicationPriorityQosPolicy':
        """
        Get an existing ApplicationPriorityQosPolicy resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: The description of the Policy
        :param pulumi.Input[str] feature_profile_id: Feature Profile ID
        :param pulumi.Input[str] name: The name of the Policy
        :param pulumi.Input[Sequence[pulumi.Input[Union['ApplicationPriorityQosPolicyQosSchedulerArgs', 'ApplicationPriorityQosPolicyQosSchedulerArgsDict']]]] qos_schedulers: qosSchedulers
        :param pulumi.Input[str] target_interface_variable: Variable name
        :param pulumi.Input[Sequence[pulumi.Input[str]]] target_interfaces: interfaces
        :param pulumi.Input[int] version: The version of the Policy
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ApplicationPriorityQosPolicyState.__new__(_ApplicationPriorityQosPolicyState)

        __props__.__dict__["description"] = description
        __props__.__dict__["feature_profile_id"] = feature_profile_id
        __props__.__dict__["name"] = name
        __props__.__dict__["qos_schedulers"] = qos_schedulers
        __props__.__dict__["target_interface_variable"] = target_interface_variable
        __props__.__dict__["target_interfaces"] = target_interfaces
        __props__.__dict__["version"] = version
        return ApplicationPriorityQosPolicy(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        The description of the Policy
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="featureProfileId")
    def feature_profile_id(self) -> pulumi.Output[str]:
        """
        Feature Profile ID
        """
        return pulumi.get(self, "feature_profile_id")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the Policy
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="qosSchedulers")
    def qos_schedulers(self) -> pulumi.Output[Optional[Sequence['outputs.ApplicationPriorityQosPolicyQosScheduler']]]:
        """
        qosSchedulers
        """
        return pulumi.get(self, "qos_schedulers")

    @property
    @pulumi.getter(name="targetInterfaceVariable")
    def target_interface_variable(self) -> pulumi.Output[Optional[str]]:
        """
        Variable name
        """
        return pulumi.get(self, "target_interface_variable")

    @property
    @pulumi.getter(name="targetInterfaces")
    def target_interfaces(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        interfaces
        """
        return pulumi.get(self, "target_interfaces")

    @property
    @pulumi.getter
    def version(self) -> pulumi.Output[int]:
        """
        The version of the Policy
        """
        return pulumi.get(self, "version")

