# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetApplicationPriorityQosPolicyResult',
    'AwaitableGetApplicationPriorityQosPolicyResult',
    'get_application_priority_qos_policy',
    'get_application_priority_qos_policy_output',
]

@pulumi.output_type
class GetApplicationPriorityQosPolicyResult:
    """
    A collection of values returned by getApplicationPriorityQosPolicy.
    """
    def __init__(__self__, description=None, feature_profile_id=None, id=None, name=None, qos_schedulers=None, target_interface_variable=None, target_interfaces=None, version=None):
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if feature_profile_id and not isinstance(feature_profile_id, str):
            raise TypeError("Expected argument 'feature_profile_id' to be a str")
        pulumi.set(__self__, "feature_profile_id", feature_profile_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if qos_schedulers and not isinstance(qos_schedulers, list):
            raise TypeError("Expected argument 'qos_schedulers' to be a list")
        pulumi.set(__self__, "qos_schedulers", qos_schedulers)
        if target_interface_variable and not isinstance(target_interface_variable, str):
            raise TypeError("Expected argument 'target_interface_variable' to be a str")
        pulumi.set(__self__, "target_interface_variable", target_interface_variable)
        if target_interfaces and not isinstance(target_interfaces, list):
            raise TypeError("Expected argument 'target_interfaces' to be a list")
        pulumi.set(__self__, "target_interfaces", target_interfaces)
        if version and not isinstance(version, int):
            raise TypeError("Expected argument 'version' to be a int")
        pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        The description of the Policy
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="featureProfileId")
    def feature_profile_id(self) -> str:
        """
        Feature Profile ID
        """
        return pulumi.get(self, "feature_profile_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The id of the Policy
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the Policy
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="qosSchedulers")
    def qos_schedulers(self) -> Sequence['outputs.GetApplicationPriorityQosPolicyQosSchedulerResult']:
        """
        qosSchedulers
        """
        return pulumi.get(self, "qos_schedulers")

    @property
    @pulumi.getter(name="targetInterfaceVariable")
    def target_interface_variable(self) -> str:
        """
        Variable name
        """
        return pulumi.get(self, "target_interface_variable")

    @property
    @pulumi.getter(name="targetInterfaces")
    def target_interfaces(self) -> Sequence[str]:
        """
        interfaces
        """
        return pulumi.get(self, "target_interfaces")

    @property
    @pulumi.getter
    def version(self) -> int:
        """
        The version of the Policy
        """
        return pulumi.get(self, "version")


class AwaitableGetApplicationPriorityQosPolicyResult(GetApplicationPriorityQosPolicyResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetApplicationPriorityQosPolicyResult(
            description=self.description,
            feature_profile_id=self.feature_profile_id,
            id=self.id,
            name=self.name,
            qos_schedulers=self.qos_schedulers,
            target_interface_variable=self.target_interface_variable,
            target_interfaces=self.target_interfaces,
            version=self.version)


def get_application_priority_qos_policy(feature_profile_id: Optional[str] = None,
                                        id: Optional[str] = None,
                                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetApplicationPriorityQosPolicyResult:
    """
    This data source can read the Application Priority QoS Policy.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_sdwan as sdwan

    example = sdwan.get_application_priority_qos_policy(id="f6b2c44c-693c-4763-b010-895aa3d236bd",
        feature_profile_id="f6dd22c8-0b4f-496c-9a0b-6813d1f8b8ac")
    ```


    :param str feature_profile_id: Feature Profile ID
    :param str id: The id of the Policy
    """
    __args__ = dict()
    __args__['featureProfileId'] = feature_profile_id
    __args__['id'] = id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('sdwan:index/getApplicationPriorityQosPolicy:getApplicationPriorityQosPolicy', __args__, opts=opts, typ=GetApplicationPriorityQosPolicyResult).value

    return AwaitableGetApplicationPriorityQosPolicyResult(
        description=pulumi.get(__ret__, 'description'),
        feature_profile_id=pulumi.get(__ret__, 'feature_profile_id'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        qos_schedulers=pulumi.get(__ret__, 'qos_schedulers'),
        target_interface_variable=pulumi.get(__ret__, 'target_interface_variable'),
        target_interfaces=pulumi.get(__ret__, 'target_interfaces'),
        version=pulumi.get(__ret__, 'version'))
def get_application_priority_qos_policy_output(feature_profile_id: Optional[pulumi.Input[str]] = None,
                                               id: Optional[pulumi.Input[str]] = None,
                                               opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetApplicationPriorityQosPolicyResult]:
    """
    This data source can read the Application Priority QoS Policy.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_sdwan as sdwan

    example = sdwan.get_application_priority_qos_policy(id="f6b2c44c-693c-4763-b010-895aa3d236bd",
        feature_profile_id="f6dd22c8-0b4f-496c-9a0b-6813d1f8b8ac")
    ```


    :param str feature_profile_id: Feature Profile ID
    :param str id: The id of the Policy
    """
    __args__ = dict()
    __args__['featureProfileId'] = feature_profile_id
    __args__['id'] = id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('sdwan:index/getApplicationPriorityQosPolicy:getApplicationPriorityQosPolicy', __args__, opts=opts, typ=GetApplicationPriorityQosPolicyResult)
    return __ret__.apply(lambda __response__: GetApplicationPriorityQosPolicyResult(
        description=pulumi.get(__response__, 'description'),
        feature_profile_id=pulumi.get(__response__, 'feature_profile_id'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        qos_schedulers=pulumi.get(__response__, 'qos_schedulers'),
        target_interface_variable=pulumi.get(__response__, 'target_interface_variable'),
        target_interfaces=pulumi.get(__response__, 'target_interfaces'),
        version=pulumi.get(__response__, 'version')))
