# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetApplicationPriorityTrafficPolicyPolicyResult',
    'AwaitableGetApplicationPriorityTrafficPolicyPolicyResult',
    'get_application_priority_traffic_policy_policy',
    'get_application_priority_traffic_policy_policy_output',
]

@pulumi.output_type
class GetApplicationPriorityTrafficPolicyPolicyResult:
    """
    A collection of values returned by getApplicationPriorityTrafficPolicyPolicy.
    """
    def __init__(__self__, default_action=None, description=None, direction=None, feature_profile_id=None, id=None, name=None, sequences=None, version=None, vpns=None):
        if default_action and not isinstance(default_action, str):
            raise TypeError("Expected argument 'default_action' to be a str")
        pulumi.set(__self__, "default_action", default_action)
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if direction and not isinstance(direction, str):
            raise TypeError("Expected argument 'direction' to be a str")
        pulumi.set(__self__, "direction", direction)
        if feature_profile_id and not isinstance(feature_profile_id, str):
            raise TypeError("Expected argument 'feature_profile_id' to be a str")
        pulumi.set(__self__, "feature_profile_id", feature_profile_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if sequences and not isinstance(sequences, list):
            raise TypeError("Expected argument 'sequences' to be a list")
        pulumi.set(__self__, "sequences", sequences)
        if version and not isinstance(version, int):
            raise TypeError("Expected argument 'version' to be a int")
        pulumi.set(__self__, "version", version)
        if vpns and not isinstance(vpns, list):
            raise TypeError("Expected argument 'vpns' to be a list")
        pulumi.set(__self__, "vpns", vpns)

    @property
    @pulumi.getter(name="defaultAction")
    def default_action(self) -> str:
        return pulumi.get(self, "default_action")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        The description of the Policy
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def direction(self) -> str:
        return pulumi.get(self, "direction")

    @property
    @pulumi.getter(name="featureProfileId")
    def feature_profile_id(self) -> str:
        """
        Feature Profile ID
        """
        return pulumi.get(self, "feature_profile_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The id of the Policy
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the Policy
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def sequences(self) -> Sequence['outputs.GetApplicationPriorityTrafficPolicyPolicySequenceResult']:
        """
        Traffic policy sequence list
        """
        return pulumi.get(self, "sequences")

    @property
    @pulumi.getter
    def version(self) -> int:
        """
        The version of the Policy
        """
        return pulumi.get(self, "version")

    @property
    @pulumi.getter
    def vpns(self) -> Sequence[str]:
        return pulumi.get(self, "vpns")


class AwaitableGetApplicationPriorityTrafficPolicyPolicyResult(GetApplicationPriorityTrafficPolicyPolicyResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetApplicationPriorityTrafficPolicyPolicyResult(
            default_action=self.default_action,
            description=self.description,
            direction=self.direction,
            feature_profile_id=self.feature_profile_id,
            id=self.id,
            name=self.name,
            sequences=self.sequences,
            version=self.version,
            vpns=self.vpns)


def get_application_priority_traffic_policy_policy(feature_profile_id: Optional[str] = None,
                                                   id: Optional[str] = None,
                                                   opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetApplicationPriorityTrafficPolicyPolicyResult:
    """
    This data source can read the Application Priority Traffic Policy Policy.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_sdwan as sdwan

    example = sdwan.get_application_priority_traffic_policy_policy(id="f6b2c44c-693c-4763-b010-895aa3d236bd",
        feature_profile_id="f6dd22c8-0b4f-496c-9a0b-6813d1f8b8ac")
    ```


    :param str feature_profile_id: Feature Profile ID
    :param str id: The id of the Policy
    """
    __args__ = dict()
    __args__['featureProfileId'] = feature_profile_id
    __args__['id'] = id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('sdwan:index/getApplicationPriorityTrafficPolicyPolicy:getApplicationPriorityTrafficPolicyPolicy', __args__, opts=opts, typ=GetApplicationPriorityTrafficPolicyPolicyResult).value

    return AwaitableGetApplicationPriorityTrafficPolicyPolicyResult(
        default_action=pulumi.get(__ret__, 'default_action'),
        description=pulumi.get(__ret__, 'description'),
        direction=pulumi.get(__ret__, 'direction'),
        feature_profile_id=pulumi.get(__ret__, 'feature_profile_id'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        sequences=pulumi.get(__ret__, 'sequences'),
        version=pulumi.get(__ret__, 'version'),
        vpns=pulumi.get(__ret__, 'vpns'))
def get_application_priority_traffic_policy_policy_output(feature_profile_id: Optional[pulumi.Input[str]] = None,
                                                          id: Optional[pulumi.Input[str]] = None,
                                                          opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetApplicationPriorityTrafficPolicyPolicyResult]:
    """
    This data source can read the Application Priority Traffic Policy Policy.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_sdwan as sdwan

    example = sdwan.get_application_priority_traffic_policy_policy(id="f6b2c44c-693c-4763-b010-895aa3d236bd",
        feature_profile_id="f6dd22c8-0b4f-496c-9a0b-6813d1f8b8ac")
    ```


    :param str feature_profile_id: Feature Profile ID
    :param str id: The id of the Policy
    """
    __args__ = dict()
    __args__['featureProfileId'] = feature_profile_id
    __args__['id'] = id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('sdwan:index/getApplicationPriorityTrafficPolicyPolicy:getApplicationPriorityTrafficPolicyPolicy', __args__, opts=opts, typ=GetApplicationPriorityTrafficPolicyPolicyResult)
    return __ret__.apply(lambda __response__: GetApplicationPriorityTrafficPolicyPolicyResult(
        default_action=pulumi.get(__response__, 'default_action'),
        description=pulumi.get(__response__, 'description'),
        direction=pulumi.get(__response__, 'direction'),
        feature_profile_id=pulumi.get(__response__, 'feature_profile_id'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        sequences=pulumi.get(__response__, 'sequences'),
        version=pulumi.get(__response__, 'version'),
        vpns=pulumi.get(__response__, 'vpns')))
