# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = [
    'GetSystemBannerFeatureResult',
    'AwaitableGetSystemBannerFeatureResult',
    'get_system_banner_feature',
    'get_system_banner_feature_output',
]

@pulumi.output_type
class GetSystemBannerFeatureResult:
    """
    A collection of values returned by getSystemBannerFeature.
    """
    def __init__(__self__, description=None, feature_profile_id=None, id=None, login=None, login_variable=None, motd=None, motd_variable=None, name=None, version=None):
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if feature_profile_id and not isinstance(feature_profile_id, str):
            raise TypeError("Expected argument 'feature_profile_id' to be a str")
        pulumi.set(__self__, "feature_profile_id", feature_profile_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if login and not isinstance(login, str):
            raise TypeError("Expected argument 'login' to be a str")
        pulumi.set(__self__, "login", login)
        if login_variable and not isinstance(login_variable, str):
            raise TypeError("Expected argument 'login_variable' to be a str")
        pulumi.set(__self__, "login_variable", login_variable)
        if motd and not isinstance(motd, str):
            raise TypeError("Expected argument 'motd' to be a str")
        pulumi.set(__self__, "motd", motd)
        if motd_variable and not isinstance(motd_variable, str):
            raise TypeError("Expected argument 'motd_variable' to be a str")
        pulumi.set(__self__, "motd_variable", motd_variable)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if version and not isinstance(version, int):
            raise TypeError("Expected argument 'version' to be a int")
        pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        The description of the Feature
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="featureProfileId")
    def feature_profile_id(self) -> str:
        """
        Feature Profile ID
        """
        return pulumi.get(self, "feature_profile_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The id of the Feature
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def login(self) -> str:
        return pulumi.get(self, "login")

    @property
    @pulumi.getter(name="loginVariable")
    def login_variable(self) -> str:
        """
        Variable name
        """
        return pulumi.get(self, "login_variable")

    @property
    @pulumi.getter
    def motd(self) -> str:
        return pulumi.get(self, "motd")

    @property
    @pulumi.getter(name="motdVariable")
    def motd_variable(self) -> str:
        """
        Variable name
        """
        return pulumi.get(self, "motd_variable")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the Feature
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def version(self) -> int:
        """
        The version of the Feature
        """
        return pulumi.get(self, "version")


class AwaitableGetSystemBannerFeatureResult(GetSystemBannerFeatureResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetSystemBannerFeatureResult(
            description=self.description,
            feature_profile_id=self.feature_profile_id,
            id=self.id,
            login=self.login,
            login_variable=self.login_variable,
            motd=self.motd,
            motd_variable=self.motd_variable,
            name=self.name,
            version=self.version)


def get_system_banner_feature(feature_profile_id: Optional[str] = None,
                              id: Optional[str] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetSystemBannerFeatureResult:
    """
    This data source can read the System Banner Feature.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_sdwan as sdwan

    example = sdwan.get_system_banner_feature(id="f6b2c44c-693c-4763-b010-895aa3d236bd",
        feature_profile_id="f6dd22c8-0b4f-496c-9a0b-6813d1f8b8ac")
    ```


    :param str feature_profile_id: Feature Profile ID
    :param str id: The id of the Feature
    """
    __args__ = dict()
    __args__['featureProfileId'] = feature_profile_id
    __args__['id'] = id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('sdwan:index/getSystemBannerFeature:getSystemBannerFeature', __args__, opts=opts, typ=GetSystemBannerFeatureResult).value

    return AwaitableGetSystemBannerFeatureResult(
        description=pulumi.get(__ret__, 'description'),
        feature_profile_id=pulumi.get(__ret__, 'feature_profile_id'),
        id=pulumi.get(__ret__, 'id'),
        login=pulumi.get(__ret__, 'login'),
        login_variable=pulumi.get(__ret__, 'login_variable'),
        motd=pulumi.get(__ret__, 'motd'),
        motd_variable=pulumi.get(__ret__, 'motd_variable'),
        name=pulumi.get(__ret__, 'name'),
        version=pulumi.get(__ret__, 'version'))
def get_system_banner_feature_output(feature_profile_id: Optional[pulumi.Input[str]] = None,
                                     id: Optional[pulumi.Input[str]] = None,
                                     opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetSystemBannerFeatureResult]:
    """
    This data source can read the System Banner Feature.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_sdwan as sdwan

    example = sdwan.get_system_banner_feature(id="f6b2c44c-693c-4763-b010-895aa3d236bd",
        feature_profile_id="f6dd22c8-0b4f-496c-9a0b-6813d1f8b8ac")
    ```


    :param str feature_profile_id: Feature Profile ID
    :param str id: The id of the Feature
    """
    __args__ = dict()
    __args__['featureProfileId'] = feature_profile_id
    __args__['id'] = id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('sdwan:index/getSystemBannerFeature:getSystemBannerFeature', __args__, opts=opts, typ=GetSystemBannerFeatureResult)
    return __ret__.apply(lambda __response__: GetSystemBannerFeatureResult(
        description=pulumi.get(__response__, 'description'),
        feature_profile_id=pulumi.get(__response__, 'feature_profile_id'),
        id=pulumi.get(__response__, 'id'),
        login=pulumi.get(__response__, 'login'),
        login_variable=pulumi.get(__response__, 'login_variable'),
        motd=pulumi.get(__response__, 'motd'),
        motd_variable=pulumi.get(__response__, 'motd_variable'),
        name=pulumi.get(__response__, 'name'),
        version=pulumi.get(__response__, 'version')))
