# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = [
    'GetSystemFlexiblePortSpeedFeatureResult',
    'AwaitableGetSystemFlexiblePortSpeedFeatureResult',
    'get_system_flexible_port_speed_feature',
    'get_system_flexible_port_speed_feature_output',
]

@pulumi.output_type
class GetSystemFlexiblePortSpeedFeatureResult:
    """
    A collection of values returned by getSystemFlexiblePortSpeedFeature.
    """
    def __init__(__self__, description=None, feature_profile_id=None, id=None, name=None, port_type=None, port_type_variable=None, version=None):
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if feature_profile_id and not isinstance(feature_profile_id, str):
            raise TypeError("Expected argument 'feature_profile_id' to be a str")
        pulumi.set(__self__, "feature_profile_id", feature_profile_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if port_type and not isinstance(port_type, str):
            raise TypeError("Expected argument 'port_type' to be a str")
        pulumi.set(__self__, "port_type", port_type)
        if port_type_variable and not isinstance(port_type_variable, str):
            raise TypeError("Expected argument 'port_type_variable' to be a str")
        pulumi.set(__self__, "port_type_variable", port_type_variable)
        if version and not isinstance(version, int):
            raise TypeError("Expected argument 'version' to be a int")
        pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        The description of the Feature
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="featureProfileId")
    def feature_profile_id(self) -> str:
        """
        Feature Profile ID
        """
        return pulumi.get(self, "feature_profile_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The id of the Feature
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the Feature
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="portType")
    def port_type(self) -> str:
        """
        port Type
        """
        return pulumi.get(self, "port_type")

    @property
    @pulumi.getter(name="portTypeVariable")
    def port_type_variable(self) -> str:
        """
        Variable name
        """
        return pulumi.get(self, "port_type_variable")

    @property
    @pulumi.getter
    def version(self) -> int:
        """
        The version of the Feature
        """
        return pulumi.get(self, "version")


class AwaitableGetSystemFlexiblePortSpeedFeatureResult(GetSystemFlexiblePortSpeedFeatureResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetSystemFlexiblePortSpeedFeatureResult(
            description=self.description,
            feature_profile_id=self.feature_profile_id,
            id=self.id,
            name=self.name,
            port_type=self.port_type,
            port_type_variable=self.port_type_variable,
            version=self.version)


def get_system_flexible_port_speed_feature(feature_profile_id: Optional[str] = None,
                                           id: Optional[str] = None,
                                           opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetSystemFlexiblePortSpeedFeatureResult:
    """
    This data source can read the System Flexible Port Speed Feature.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_sdwan as sdwan

    example = sdwan.get_system_flexible_port_speed_feature(id="f6b2c44c-693c-4763-b010-895aa3d236bd",
        feature_profile_id="f6dd22c8-0b4f-496c-9a0b-6813d1f8b8ac")
    ```


    :param str feature_profile_id: Feature Profile ID
    :param str id: The id of the Feature
    """
    __args__ = dict()
    __args__['featureProfileId'] = feature_profile_id
    __args__['id'] = id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('sdwan:index/getSystemFlexiblePortSpeedFeature:getSystemFlexiblePortSpeedFeature', __args__, opts=opts, typ=GetSystemFlexiblePortSpeedFeatureResult).value

    return AwaitableGetSystemFlexiblePortSpeedFeatureResult(
        description=pulumi.get(__ret__, 'description'),
        feature_profile_id=pulumi.get(__ret__, 'feature_profile_id'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        port_type=pulumi.get(__ret__, 'port_type'),
        port_type_variable=pulumi.get(__ret__, 'port_type_variable'),
        version=pulumi.get(__ret__, 'version'))
def get_system_flexible_port_speed_feature_output(feature_profile_id: Optional[pulumi.Input[str]] = None,
                                                  id: Optional[pulumi.Input[str]] = None,
                                                  opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetSystemFlexiblePortSpeedFeatureResult]:
    """
    This data source can read the System Flexible Port Speed Feature.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_sdwan as sdwan

    example = sdwan.get_system_flexible_port_speed_feature(id="f6b2c44c-693c-4763-b010-895aa3d236bd",
        feature_profile_id="f6dd22c8-0b4f-496c-9a0b-6813d1f8b8ac")
    ```


    :param str feature_profile_id: Feature Profile ID
    :param str id: The id of the Feature
    """
    __args__ = dict()
    __args__['featureProfileId'] = feature_profile_id
    __args__['id'] = id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('sdwan:index/getSystemFlexiblePortSpeedFeature:getSystemFlexiblePortSpeedFeature', __args__, opts=opts, typ=GetSystemFlexiblePortSpeedFeatureResult)
    return __ret__.apply(lambda __response__: GetSystemFlexiblePortSpeedFeatureResult(
        description=pulumi.get(__response__, 'description'),
        feature_profile_id=pulumi.get(__response__, 'feature_profile_id'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        port_type=pulumi.get(__response__, 'port_type'),
        port_type_variable=pulumi.get(__response__, 'port_type_variable'),
        version=pulumi.get(__response__, 'version')))
