# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetTransportT1E1ControllerFeatureResult',
    'AwaitableGetTransportT1E1ControllerFeatureResult',
    'get_transport_t1_e1_controller_feature',
    'get_transport_t1_e1_controller_feature_output',
]

@pulumi.output_type
class GetTransportT1E1ControllerFeatureResult:
    """
    A collection of values returned by getTransportT1E1ControllerFeature.
    """
    def __init__(__self__, description=None, entries=None, feature_profile_id=None, id=None, name=None, slot=None, slot_variable=None, type=None, version=None):
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if entries and not isinstance(entries, list):
            raise TypeError("Expected argument 'entries' to be a list")
        pulumi.set(__self__, "entries", entries)
        if feature_profile_id and not isinstance(feature_profile_id, str):
            raise TypeError("Expected argument 'feature_profile_id' to be a str")
        pulumi.set(__self__, "feature_profile_id", feature_profile_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if slot and not isinstance(slot, str):
            raise TypeError("Expected argument 'slot' to be a str")
        pulumi.set(__self__, "slot", slot)
        if slot_variable and not isinstance(slot_variable, str):
            raise TypeError("Expected argument 'slot_variable' to be a str")
        pulumi.set(__self__, "slot_variable", slot_variable)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)
        if version and not isinstance(version, int):
            raise TypeError("Expected argument 'version' to be a int")
        pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        The description of the Feature
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def entries(self) -> Sequence['outputs.GetTransportT1E1ControllerFeatureEntryResult']:
        """
        Controller tx-ex List
        """
        return pulumi.get(self, "entries")

    @property
    @pulumi.getter(name="featureProfileId")
    def feature_profile_id(self) -> str:
        """
        Feature Profile ID
        """
        return pulumi.get(self, "feature_profile_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The id of the Feature
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the Feature
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def slot(self) -> str:
        """
        Slot number
        """
        return pulumi.get(self, "slot")

    @property
    @pulumi.getter(name="slotVariable")
    def slot_variable(self) -> str:
        """
        Variable name
        """
        return pulumi.get(self, "slot_variable")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        Card Type
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def version(self) -> int:
        """
        The version of the Feature
        """
        return pulumi.get(self, "version")


class AwaitableGetTransportT1E1ControllerFeatureResult(GetTransportT1E1ControllerFeatureResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetTransportT1E1ControllerFeatureResult(
            description=self.description,
            entries=self.entries,
            feature_profile_id=self.feature_profile_id,
            id=self.id,
            name=self.name,
            slot=self.slot,
            slot_variable=self.slot_variable,
            type=self.type,
            version=self.version)


def get_transport_t1_e1_controller_feature(feature_profile_id: Optional[str] = None,
                                           id: Optional[str] = None,
                                           opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetTransportT1E1ControllerFeatureResult:
    """
    This data source can read the Transport T1 E1 Controller Feature.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_sdwan as sdwan

    example = sdwan.get_transport_t1_e1_controller_feature(id="f6b2c44c-693c-4763-b010-895aa3d236bd",
        feature_profile_id="f6dd22c8-0b4f-496c-9a0b-6813d1f8b8ac")
    ```


    :param str feature_profile_id: Feature Profile ID
    :param str id: The id of the Feature
    """
    __args__ = dict()
    __args__['featureProfileId'] = feature_profile_id
    __args__['id'] = id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('sdwan:index/getTransportT1E1ControllerFeature:getTransportT1E1ControllerFeature', __args__, opts=opts, typ=GetTransportT1E1ControllerFeatureResult).value

    return AwaitableGetTransportT1E1ControllerFeatureResult(
        description=pulumi.get(__ret__, 'description'),
        entries=pulumi.get(__ret__, 'entries'),
        feature_profile_id=pulumi.get(__ret__, 'feature_profile_id'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        slot=pulumi.get(__ret__, 'slot'),
        slot_variable=pulumi.get(__ret__, 'slot_variable'),
        type=pulumi.get(__ret__, 'type'),
        version=pulumi.get(__ret__, 'version'))
def get_transport_t1_e1_controller_feature_output(feature_profile_id: Optional[pulumi.Input[str]] = None,
                                                  id: Optional[pulumi.Input[str]] = None,
                                                  opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetTransportT1E1ControllerFeatureResult]:
    """
    This data source can read the Transport T1 E1 Controller Feature.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_sdwan as sdwan

    example = sdwan.get_transport_t1_e1_controller_feature(id="f6b2c44c-693c-4763-b010-895aa3d236bd",
        feature_profile_id="f6dd22c8-0b4f-496c-9a0b-6813d1f8b8ac")
    ```


    :param str feature_profile_id: Feature Profile ID
    :param str id: The id of the Feature
    """
    __args__ = dict()
    __args__['featureProfileId'] = feature_profile_id
    __args__['id'] = id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('sdwan:index/getTransportT1E1ControllerFeature:getTransportT1E1ControllerFeature', __args__, opts=opts, typ=GetTransportT1E1ControllerFeatureResult)
    return __ret__.apply(lambda __response__: GetTransportT1E1ControllerFeatureResult(
        description=pulumi.get(__response__, 'description'),
        entries=pulumi.get(__response__, 'entries'),
        feature_profile_id=pulumi.get(__response__, 'feature_profile_id'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        slot=pulumi.get(__response__, 'slot'),
        slot_variable=pulumi.get(__response__, 'slot_variable'),
        type=pulumi.get(__response__, 'type'),
        version=pulumi.get(__response__, 'version')))
