# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetTransportTrackerGroupFeatureResult',
    'AwaitableGetTransportTrackerGroupFeatureResult',
    'get_transport_tracker_group_feature',
    'get_transport_tracker_group_feature_output',
]

@pulumi.output_type
class GetTransportTrackerGroupFeatureResult:
    """
    A collection of values returned by getTransportTrackerGroupFeature.
    """
    def __init__(__self__, description=None, feature_profile_id=None, id=None, name=None, tracker_boolean=None, tracker_boolean_variable=None, tracker_elements=None, version=None):
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if feature_profile_id and not isinstance(feature_profile_id, str):
            raise TypeError("Expected argument 'feature_profile_id' to be a str")
        pulumi.set(__self__, "feature_profile_id", feature_profile_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if tracker_boolean and not isinstance(tracker_boolean, str):
            raise TypeError("Expected argument 'tracker_boolean' to be a str")
        pulumi.set(__self__, "tracker_boolean", tracker_boolean)
        if tracker_boolean_variable and not isinstance(tracker_boolean_variable, str):
            raise TypeError("Expected argument 'tracker_boolean_variable' to be a str")
        pulumi.set(__self__, "tracker_boolean_variable", tracker_boolean_variable)
        if tracker_elements and not isinstance(tracker_elements, list):
            raise TypeError("Expected argument 'tracker_elements' to be a list")
        pulumi.set(__self__, "tracker_elements", tracker_elements)
        if version and not isinstance(version, int):
            raise TypeError("Expected argument 'version' to be a int")
        pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        The description of the Feature
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="featureProfileId")
    def feature_profile_id(self) -> str:
        """
        Feature Profile ID
        """
        return pulumi.get(self, "feature_profile_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The id of the Feature
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the Feature
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="trackerBoolean")
    def tracker_boolean(self) -> str:
        """
        tracker ref list combine boolean and or
        """
        return pulumi.get(self, "tracker_boolean")

    @property
    @pulumi.getter(name="trackerBooleanVariable")
    def tracker_boolean_variable(self) -> str:
        """
        Variable name
        """
        return pulumi.get(self, "tracker_boolean_variable")

    @property
    @pulumi.getter(name="trackerElements")
    def tracker_elements(self) -> Sequence['outputs.GetTransportTrackerGroupFeatureTrackerElementResult']:
        """
        tracker parcel ref list
        """
        return pulumi.get(self, "tracker_elements")

    @property
    @pulumi.getter
    def version(self) -> int:
        """
        The version of the Feature
        """
        return pulumi.get(self, "version")


class AwaitableGetTransportTrackerGroupFeatureResult(GetTransportTrackerGroupFeatureResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetTransportTrackerGroupFeatureResult(
            description=self.description,
            feature_profile_id=self.feature_profile_id,
            id=self.id,
            name=self.name,
            tracker_boolean=self.tracker_boolean,
            tracker_boolean_variable=self.tracker_boolean_variable,
            tracker_elements=self.tracker_elements,
            version=self.version)


def get_transport_tracker_group_feature(feature_profile_id: Optional[str] = None,
                                        id: Optional[str] = None,
                                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetTransportTrackerGroupFeatureResult:
    """
    This data source can read the Transport Tracker Group Feature.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_sdwan as sdwan

    example = sdwan.get_transport_tracker_group_feature(id="f6b2c44c-693c-4763-b010-895aa3d236bd",
        feature_profile_id="f6dd22c8-0b4f-496c-9a0b-6813d1f8b8ac")
    ```


    :param str feature_profile_id: Feature Profile ID
    :param str id: The id of the Feature
    """
    __args__ = dict()
    __args__['featureProfileId'] = feature_profile_id
    __args__['id'] = id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('sdwan:index/getTransportTrackerGroupFeature:getTransportTrackerGroupFeature', __args__, opts=opts, typ=GetTransportTrackerGroupFeatureResult).value

    return AwaitableGetTransportTrackerGroupFeatureResult(
        description=pulumi.get(__ret__, 'description'),
        feature_profile_id=pulumi.get(__ret__, 'feature_profile_id'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        tracker_boolean=pulumi.get(__ret__, 'tracker_boolean'),
        tracker_boolean_variable=pulumi.get(__ret__, 'tracker_boolean_variable'),
        tracker_elements=pulumi.get(__ret__, 'tracker_elements'),
        version=pulumi.get(__ret__, 'version'))
def get_transport_tracker_group_feature_output(feature_profile_id: Optional[pulumi.Input[str]] = None,
                                               id: Optional[pulumi.Input[str]] = None,
                                               opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetTransportTrackerGroupFeatureResult]:
    """
    This data source can read the Transport Tracker Group Feature.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_sdwan as sdwan

    example = sdwan.get_transport_tracker_group_feature(id="f6b2c44c-693c-4763-b010-895aa3d236bd",
        feature_profile_id="f6dd22c8-0b4f-496c-9a0b-6813d1f8b8ac")
    ```


    :param str feature_profile_id: Feature Profile ID
    :param str id: The id of the Feature
    """
    __args__ = dict()
    __args__['featureProfileId'] = feature_profile_id
    __args__['id'] = id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('sdwan:index/getTransportTrackerGroupFeature:getTransportTrackerGroupFeature', __args__, opts=opts, typ=GetTransportTrackerGroupFeatureResult)
    return __ret__.apply(lambda __response__: GetTransportTrackerGroupFeatureResult(
        description=pulumi.get(__response__, 'description'),
        feature_profile_id=pulumi.get(__response__, 'feature_profile_id'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        tracker_boolean=pulumi.get(__response__, 'tracker_boolean'),
        tracker_boolean_variable=pulumi.get(__response__, 'tracker_boolean_variable'),
        tracker_elements=pulumi.get(__response__, 'tracker_elements'),
        version=pulumi.get(__response__, 'version')))
