# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['TransportManagementVpnFeatureArgs', 'TransportManagementVpnFeature']

@pulumi.input_type
class TransportManagementVpnFeatureArgs:
    def __init__(__self__, *,
                 description: Optional[pulumi.Input[str]] = None,
                 feature_profile_id: Optional[pulumi.Input[str]] = None,
                 ipv4_static_routes: Optional[pulumi.Input[Sequence[pulumi.Input['TransportManagementVpnFeatureIpv4StaticRouteArgs']]]] = None,
                 ipv6_static_routes: Optional[pulumi.Input[Sequence[pulumi.Input['TransportManagementVpnFeatureIpv6StaticRouteArgs']]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 new_host_mappings: Optional[pulumi.Input[Sequence[pulumi.Input['TransportManagementVpnFeatureNewHostMappingArgs']]]] = None,
                 primary_dns_address_ipv4: Optional[pulumi.Input[str]] = None,
                 primary_dns_address_ipv4_variable: Optional[pulumi.Input[str]] = None,
                 primary_dns_address_ipv6: Optional[pulumi.Input[str]] = None,
                 primary_dns_address_ipv6_variable: Optional[pulumi.Input[str]] = None,
                 secondary_dns_address_ipv4: Optional[pulumi.Input[str]] = None,
                 secondary_dns_address_ipv4_variable: Optional[pulumi.Input[str]] = None,
                 secondary_dns_address_ipv6: Optional[pulumi.Input[str]] = None,
                 secondary_dns_address_ipv6_variable: Optional[pulumi.Input[str]] = None,
                 vpn_description: Optional[pulumi.Input[str]] = None,
                 vpn_description_variable: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a TransportManagementVpnFeature resource.
        :param pulumi.Input[str] description: The description of the Feature
        :param pulumi.Input[str] feature_profile_id: Feature Profile ID
        :param pulumi.Input[Sequence[pulumi.Input['TransportManagementVpnFeatureIpv4StaticRouteArgs']]] ipv4_static_routes: IPv4 Static Route
        :param pulumi.Input[Sequence[pulumi.Input['TransportManagementVpnFeatureIpv6StaticRouteArgs']]] ipv6_static_routes: IPv6 Static Route
        :param pulumi.Input[str] name: The name of the Feature
        :param pulumi.Input[str] primary_dns_address_ipv4: Primary DNS Address (IPv4)
        :param pulumi.Input[str] primary_dns_address_ipv4_variable: Variable name
        :param pulumi.Input[str] primary_dns_address_ipv6: Primary DNS Address (IPv6)
        :param pulumi.Input[str] primary_dns_address_ipv6_variable: Variable name
        :param pulumi.Input[str] secondary_dns_address_ipv4: Secondary DNS Address (IPv4)
        :param pulumi.Input[str] secondary_dns_address_ipv4_variable: Variable name
        :param pulumi.Input[str] secondary_dns_address_ipv6: Secondary DNS Address (IPv6)
        :param pulumi.Input[str] secondary_dns_address_ipv6_variable: Variable name
        :param pulumi.Input[str] vpn_description: Name
        :param pulumi.Input[str] vpn_description_variable: Variable name
        """
        if description is not None:
            pulumi.set(__self__, "description", description)
        if feature_profile_id is not None:
            pulumi.set(__self__, "feature_profile_id", feature_profile_id)
        if ipv4_static_routes is not None:
            pulumi.set(__self__, "ipv4_static_routes", ipv4_static_routes)
        if ipv6_static_routes is not None:
            pulumi.set(__self__, "ipv6_static_routes", ipv6_static_routes)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if new_host_mappings is not None:
            pulumi.set(__self__, "new_host_mappings", new_host_mappings)
        if primary_dns_address_ipv4 is not None:
            pulumi.set(__self__, "primary_dns_address_ipv4", primary_dns_address_ipv4)
        if primary_dns_address_ipv4_variable is not None:
            pulumi.set(__self__, "primary_dns_address_ipv4_variable", primary_dns_address_ipv4_variable)
        if primary_dns_address_ipv6 is not None:
            pulumi.set(__self__, "primary_dns_address_ipv6", primary_dns_address_ipv6)
        if primary_dns_address_ipv6_variable is not None:
            pulumi.set(__self__, "primary_dns_address_ipv6_variable", primary_dns_address_ipv6_variable)
        if secondary_dns_address_ipv4 is not None:
            pulumi.set(__self__, "secondary_dns_address_ipv4", secondary_dns_address_ipv4)
        if secondary_dns_address_ipv4_variable is not None:
            pulumi.set(__self__, "secondary_dns_address_ipv4_variable", secondary_dns_address_ipv4_variable)
        if secondary_dns_address_ipv6 is not None:
            pulumi.set(__self__, "secondary_dns_address_ipv6", secondary_dns_address_ipv6)
        if secondary_dns_address_ipv6_variable is not None:
            pulumi.set(__self__, "secondary_dns_address_ipv6_variable", secondary_dns_address_ipv6_variable)
        if vpn_description is not None:
            pulumi.set(__self__, "vpn_description", vpn_description)
        if vpn_description_variable is not None:
            pulumi.set(__self__, "vpn_description_variable", vpn_description_variable)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        The description of the Feature
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="featureProfileId")
    def feature_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        Feature Profile ID
        """
        return pulumi.get(self, "feature_profile_id")

    @feature_profile_id.setter
    def feature_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "feature_profile_id", value)

    @property
    @pulumi.getter(name="ipv4StaticRoutes")
    def ipv4_static_routes(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['TransportManagementVpnFeatureIpv4StaticRouteArgs']]]]:
        """
        IPv4 Static Route
        """
        return pulumi.get(self, "ipv4_static_routes")

    @ipv4_static_routes.setter
    def ipv4_static_routes(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['TransportManagementVpnFeatureIpv4StaticRouteArgs']]]]):
        pulumi.set(self, "ipv4_static_routes", value)

    @property
    @pulumi.getter(name="ipv6StaticRoutes")
    def ipv6_static_routes(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['TransportManagementVpnFeatureIpv6StaticRouteArgs']]]]:
        """
        IPv6 Static Route
        """
        return pulumi.get(self, "ipv6_static_routes")

    @ipv6_static_routes.setter
    def ipv6_static_routes(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['TransportManagementVpnFeatureIpv6StaticRouteArgs']]]]):
        pulumi.set(self, "ipv6_static_routes", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the Feature
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="newHostMappings")
    def new_host_mappings(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['TransportManagementVpnFeatureNewHostMappingArgs']]]]:
        return pulumi.get(self, "new_host_mappings")

    @new_host_mappings.setter
    def new_host_mappings(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['TransportManagementVpnFeatureNewHostMappingArgs']]]]):
        pulumi.set(self, "new_host_mappings", value)

    @property
    @pulumi.getter(name="primaryDnsAddressIpv4")
    def primary_dns_address_ipv4(self) -> Optional[pulumi.Input[str]]:
        """
        Primary DNS Address (IPv4)
        """
        return pulumi.get(self, "primary_dns_address_ipv4")

    @primary_dns_address_ipv4.setter
    def primary_dns_address_ipv4(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "primary_dns_address_ipv4", value)

    @property
    @pulumi.getter(name="primaryDnsAddressIpv4Variable")
    def primary_dns_address_ipv4_variable(self) -> Optional[pulumi.Input[str]]:
        """
        Variable name
        """
        return pulumi.get(self, "primary_dns_address_ipv4_variable")

    @primary_dns_address_ipv4_variable.setter
    def primary_dns_address_ipv4_variable(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "primary_dns_address_ipv4_variable", value)

    @property
    @pulumi.getter(name="primaryDnsAddressIpv6")
    def primary_dns_address_ipv6(self) -> Optional[pulumi.Input[str]]:
        """
        Primary DNS Address (IPv6)
        """
        return pulumi.get(self, "primary_dns_address_ipv6")

    @primary_dns_address_ipv6.setter
    def primary_dns_address_ipv6(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "primary_dns_address_ipv6", value)

    @property
    @pulumi.getter(name="primaryDnsAddressIpv6Variable")
    def primary_dns_address_ipv6_variable(self) -> Optional[pulumi.Input[str]]:
        """
        Variable name
        """
        return pulumi.get(self, "primary_dns_address_ipv6_variable")

    @primary_dns_address_ipv6_variable.setter
    def primary_dns_address_ipv6_variable(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "primary_dns_address_ipv6_variable", value)

    @property
    @pulumi.getter(name="secondaryDnsAddressIpv4")
    def secondary_dns_address_ipv4(self) -> Optional[pulumi.Input[str]]:
        """
        Secondary DNS Address (IPv4)
        """
        return pulumi.get(self, "secondary_dns_address_ipv4")

    @secondary_dns_address_ipv4.setter
    def secondary_dns_address_ipv4(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "secondary_dns_address_ipv4", value)

    @property
    @pulumi.getter(name="secondaryDnsAddressIpv4Variable")
    def secondary_dns_address_ipv4_variable(self) -> Optional[pulumi.Input[str]]:
        """
        Variable name
        """
        return pulumi.get(self, "secondary_dns_address_ipv4_variable")

    @secondary_dns_address_ipv4_variable.setter
    def secondary_dns_address_ipv4_variable(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "secondary_dns_address_ipv4_variable", value)

    @property
    @pulumi.getter(name="secondaryDnsAddressIpv6")
    def secondary_dns_address_ipv6(self) -> Optional[pulumi.Input[str]]:
        """
        Secondary DNS Address (IPv6)
        """
        return pulumi.get(self, "secondary_dns_address_ipv6")

    @secondary_dns_address_ipv6.setter
    def secondary_dns_address_ipv6(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "secondary_dns_address_ipv6", value)

    @property
    @pulumi.getter(name="secondaryDnsAddressIpv6Variable")
    def secondary_dns_address_ipv6_variable(self) -> Optional[pulumi.Input[str]]:
        """
        Variable name
        """
        return pulumi.get(self, "secondary_dns_address_ipv6_variable")

    @secondary_dns_address_ipv6_variable.setter
    def secondary_dns_address_ipv6_variable(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "secondary_dns_address_ipv6_variable", value)

    @property
    @pulumi.getter(name="vpnDescription")
    def vpn_description(self) -> Optional[pulumi.Input[str]]:
        """
        Name
        """
        return pulumi.get(self, "vpn_description")

    @vpn_description.setter
    def vpn_description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vpn_description", value)

    @property
    @pulumi.getter(name="vpnDescriptionVariable")
    def vpn_description_variable(self) -> Optional[pulumi.Input[str]]:
        """
        Variable name
        """
        return pulumi.get(self, "vpn_description_variable")

    @vpn_description_variable.setter
    def vpn_description_variable(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vpn_description_variable", value)


@pulumi.input_type
class _TransportManagementVpnFeatureState:
    def __init__(__self__, *,
                 description: Optional[pulumi.Input[str]] = None,
                 feature_profile_id: Optional[pulumi.Input[str]] = None,
                 ipv4_static_routes: Optional[pulumi.Input[Sequence[pulumi.Input['TransportManagementVpnFeatureIpv4StaticRouteArgs']]]] = None,
                 ipv6_static_routes: Optional[pulumi.Input[Sequence[pulumi.Input['TransportManagementVpnFeatureIpv6StaticRouteArgs']]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 new_host_mappings: Optional[pulumi.Input[Sequence[pulumi.Input['TransportManagementVpnFeatureNewHostMappingArgs']]]] = None,
                 primary_dns_address_ipv4: Optional[pulumi.Input[str]] = None,
                 primary_dns_address_ipv4_variable: Optional[pulumi.Input[str]] = None,
                 primary_dns_address_ipv6: Optional[pulumi.Input[str]] = None,
                 primary_dns_address_ipv6_variable: Optional[pulumi.Input[str]] = None,
                 secondary_dns_address_ipv4: Optional[pulumi.Input[str]] = None,
                 secondary_dns_address_ipv4_variable: Optional[pulumi.Input[str]] = None,
                 secondary_dns_address_ipv6: Optional[pulumi.Input[str]] = None,
                 secondary_dns_address_ipv6_variable: Optional[pulumi.Input[str]] = None,
                 version: Optional[pulumi.Input[int]] = None,
                 vpn_description: Optional[pulumi.Input[str]] = None,
                 vpn_description_variable: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering TransportManagementVpnFeature resources.
        :param pulumi.Input[str] description: The description of the Feature
        :param pulumi.Input[str] feature_profile_id: Feature Profile ID
        :param pulumi.Input[Sequence[pulumi.Input['TransportManagementVpnFeatureIpv4StaticRouteArgs']]] ipv4_static_routes: IPv4 Static Route
        :param pulumi.Input[Sequence[pulumi.Input['TransportManagementVpnFeatureIpv6StaticRouteArgs']]] ipv6_static_routes: IPv6 Static Route
        :param pulumi.Input[str] name: The name of the Feature
        :param pulumi.Input[str] primary_dns_address_ipv4: Primary DNS Address (IPv4)
        :param pulumi.Input[str] primary_dns_address_ipv4_variable: Variable name
        :param pulumi.Input[str] primary_dns_address_ipv6: Primary DNS Address (IPv6)
        :param pulumi.Input[str] primary_dns_address_ipv6_variable: Variable name
        :param pulumi.Input[str] secondary_dns_address_ipv4: Secondary DNS Address (IPv4)
        :param pulumi.Input[str] secondary_dns_address_ipv4_variable: Variable name
        :param pulumi.Input[str] secondary_dns_address_ipv6: Secondary DNS Address (IPv6)
        :param pulumi.Input[str] secondary_dns_address_ipv6_variable: Variable name
        :param pulumi.Input[int] version: The version of the Feature
        :param pulumi.Input[str] vpn_description: Name
        :param pulumi.Input[str] vpn_description_variable: Variable name
        """
        if description is not None:
            pulumi.set(__self__, "description", description)
        if feature_profile_id is not None:
            pulumi.set(__self__, "feature_profile_id", feature_profile_id)
        if ipv4_static_routes is not None:
            pulumi.set(__self__, "ipv4_static_routes", ipv4_static_routes)
        if ipv6_static_routes is not None:
            pulumi.set(__self__, "ipv6_static_routes", ipv6_static_routes)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if new_host_mappings is not None:
            pulumi.set(__self__, "new_host_mappings", new_host_mappings)
        if primary_dns_address_ipv4 is not None:
            pulumi.set(__self__, "primary_dns_address_ipv4", primary_dns_address_ipv4)
        if primary_dns_address_ipv4_variable is not None:
            pulumi.set(__self__, "primary_dns_address_ipv4_variable", primary_dns_address_ipv4_variable)
        if primary_dns_address_ipv6 is not None:
            pulumi.set(__self__, "primary_dns_address_ipv6", primary_dns_address_ipv6)
        if primary_dns_address_ipv6_variable is not None:
            pulumi.set(__self__, "primary_dns_address_ipv6_variable", primary_dns_address_ipv6_variable)
        if secondary_dns_address_ipv4 is not None:
            pulumi.set(__self__, "secondary_dns_address_ipv4", secondary_dns_address_ipv4)
        if secondary_dns_address_ipv4_variable is not None:
            pulumi.set(__self__, "secondary_dns_address_ipv4_variable", secondary_dns_address_ipv4_variable)
        if secondary_dns_address_ipv6 is not None:
            pulumi.set(__self__, "secondary_dns_address_ipv6", secondary_dns_address_ipv6)
        if secondary_dns_address_ipv6_variable is not None:
            pulumi.set(__self__, "secondary_dns_address_ipv6_variable", secondary_dns_address_ipv6_variable)
        if version is not None:
            pulumi.set(__self__, "version", version)
        if vpn_description is not None:
            pulumi.set(__self__, "vpn_description", vpn_description)
        if vpn_description_variable is not None:
            pulumi.set(__self__, "vpn_description_variable", vpn_description_variable)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        The description of the Feature
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="featureProfileId")
    def feature_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        Feature Profile ID
        """
        return pulumi.get(self, "feature_profile_id")

    @feature_profile_id.setter
    def feature_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "feature_profile_id", value)

    @property
    @pulumi.getter(name="ipv4StaticRoutes")
    def ipv4_static_routes(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['TransportManagementVpnFeatureIpv4StaticRouteArgs']]]]:
        """
        IPv4 Static Route
        """
        return pulumi.get(self, "ipv4_static_routes")

    @ipv4_static_routes.setter
    def ipv4_static_routes(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['TransportManagementVpnFeatureIpv4StaticRouteArgs']]]]):
        pulumi.set(self, "ipv4_static_routes", value)

    @property
    @pulumi.getter(name="ipv6StaticRoutes")
    def ipv6_static_routes(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['TransportManagementVpnFeatureIpv6StaticRouteArgs']]]]:
        """
        IPv6 Static Route
        """
        return pulumi.get(self, "ipv6_static_routes")

    @ipv6_static_routes.setter
    def ipv6_static_routes(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['TransportManagementVpnFeatureIpv6StaticRouteArgs']]]]):
        pulumi.set(self, "ipv6_static_routes", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the Feature
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="newHostMappings")
    def new_host_mappings(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['TransportManagementVpnFeatureNewHostMappingArgs']]]]:
        return pulumi.get(self, "new_host_mappings")

    @new_host_mappings.setter
    def new_host_mappings(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['TransportManagementVpnFeatureNewHostMappingArgs']]]]):
        pulumi.set(self, "new_host_mappings", value)

    @property
    @pulumi.getter(name="primaryDnsAddressIpv4")
    def primary_dns_address_ipv4(self) -> Optional[pulumi.Input[str]]:
        """
        Primary DNS Address (IPv4)
        """
        return pulumi.get(self, "primary_dns_address_ipv4")

    @primary_dns_address_ipv4.setter
    def primary_dns_address_ipv4(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "primary_dns_address_ipv4", value)

    @property
    @pulumi.getter(name="primaryDnsAddressIpv4Variable")
    def primary_dns_address_ipv4_variable(self) -> Optional[pulumi.Input[str]]:
        """
        Variable name
        """
        return pulumi.get(self, "primary_dns_address_ipv4_variable")

    @primary_dns_address_ipv4_variable.setter
    def primary_dns_address_ipv4_variable(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "primary_dns_address_ipv4_variable", value)

    @property
    @pulumi.getter(name="primaryDnsAddressIpv6")
    def primary_dns_address_ipv6(self) -> Optional[pulumi.Input[str]]:
        """
        Primary DNS Address (IPv6)
        """
        return pulumi.get(self, "primary_dns_address_ipv6")

    @primary_dns_address_ipv6.setter
    def primary_dns_address_ipv6(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "primary_dns_address_ipv6", value)

    @property
    @pulumi.getter(name="primaryDnsAddressIpv6Variable")
    def primary_dns_address_ipv6_variable(self) -> Optional[pulumi.Input[str]]:
        """
        Variable name
        """
        return pulumi.get(self, "primary_dns_address_ipv6_variable")

    @primary_dns_address_ipv6_variable.setter
    def primary_dns_address_ipv6_variable(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "primary_dns_address_ipv6_variable", value)

    @property
    @pulumi.getter(name="secondaryDnsAddressIpv4")
    def secondary_dns_address_ipv4(self) -> Optional[pulumi.Input[str]]:
        """
        Secondary DNS Address (IPv4)
        """
        return pulumi.get(self, "secondary_dns_address_ipv4")

    @secondary_dns_address_ipv4.setter
    def secondary_dns_address_ipv4(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "secondary_dns_address_ipv4", value)

    @property
    @pulumi.getter(name="secondaryDnsAddressIpv4Variable")
    def secondary_dns_address_ipv4_variable(self) -> Optional[pulumi.Input[str]]:
        """
        Variable name
        """
        return pulumi.get(self, "secondary_dns_address_ipv4_variable")

    @secondary_dns_address_ipv4_variable.setter
    def secondary_dns_address_ipv4_variable(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "secondary_dns_address_ipv4_variable", value)

    @property
    @pulumi.getter(name="secondaryDnsAddressIpv6")
    def secondary_dns_address_ipv6(self) -> Optional[pulumi.Input[str]]:
        """
        Secondary DNS Address (IPv6)
        """
        return pulumi.get(self, "secondary_dns_address_ipv6")

    @secondary_dns_address_ipv6.setter
    def secondary_dns_address_ipv6(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "secondary_dns_address_ipv6", value)

    @property
    @pulumi.getter(name="secondaryDnsAddressIpv6Variable")
    def secondary_dns_address_ipv6_variable(self) -> Optional[pulumi.Input[str]]:
        """
        Variable name
        """
        return pulumi.get(self, "secondary_dns_address_ipv6_variable")

    @secondary_dns_address_ipv6_variable.setter
    def secondary_dns_address_ipv6_variable(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "secondary_dns_address_ipv6_variable", value)

    @property
    @pulumi.getter
    def version(self) -> Optional[pulumi.Input[int]]:
        """
        The version of the Feature
        """
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "version", value)

    @property
    @pulumi.getter(name="vpnDescription")
    def vpn_description(self) -> Optional[pulumi.Input[str]]:
        """
        Name
        """
        return pulumi.get(self, "vpn_description")

    @vpn_description.setter
    def vpn_description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vpn_description", value)

    @property
    @pulumi.getter(name="vpnDescriptionVariable")
    def vpn_description_variable(self) -> Optional[pulumi.Input[str]]:
        """
        Variable name
        """
        return pulumi.get(self, "vpn_description_variable")

    @vpn_description_variable.setter
    def vpn_description_variable(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vpn_description_variable", value)


class TransportManagementVpnFeature(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 feature_profile_id: Optional[pulumi.Input[str]] = None,
                 ipv4_static_routes: Optional[pulumi.Input[Sequence[pulumi.Input[Union['TransportManagementVpnFeatureIpv4StaticRouteArgs', 'TransportManagementVpnFeatureIpv4StaticRouteArgsDict']]]]] = None,
                 ipv6_static_routes: Optional[pulumi.Input[Sequence[pulumi.Input[Union['TransportManagementVpnFeatureIpv6StaticRouteArgs', 'TransportManagementVpnFeatureIpv6StaticRouteArgsDict']]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 new_host_mappings: Optional[pulumi.Input[Sequence[pulumi.Input[Union['TransportManagementVpnFeatureNewHostMappingArgs', 'TransportManagementVpnFeatureNewHostMappingArgsDict']]]]] = None,
                 primary_dns_address_ipv4: Optional[pulumi.Input[str]] = None,
                 primary_dns_address_ipv4_variable: Optional[pulumi.Input[str]] = None,
                 primary_dns_address_ipv6: Optional[pulumi.Input[str]] = None,
                 primary_dns_address_ipv6_variable: Optional[pulumi.Input[str]] = None,
                 secondary_dns_address_ipv4: Optional[pulumi.Input[str]] = None,
                 secondary_dns_address_ipv4_variable: Optional[pulumi.Input[str]] = None,
                 secondary_dns_address_ipv6: Optional[pulumi.Input[str]] = None,
                 secondary_dns_address_ipv6_variable: Optional[pulumi.Input[str]] = None,
                 vpn_description: Optional[pulumi.Input[str]] = None,
                 vpn_description_variable: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        This resource can manage a Transport Management VPN Feature.
          - Minimum SD-WAN Manager version: `20.12.0`

        ## Import

        Expected import identifier with the format: "transport_management_vpn_feature_id,feature_profile_id"

        ```sh
        $ pulumi import sdwan:index/transportManagementVpnFeature:TransportManagementVpnFeature example "f6b2c44c-693c-4763-b010-895aa3d236bd,f6dd22c8-0b4f-496c-9a0b-6813d1f8b8ac"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: The description of the Feature
        :param pulumi.Input[str] feature_profile_id: Feature Profile ID
        :param pulumi.Input[Sequence[pulumi.Input[Union['TransportManagementVpnFeatureIpv4StaticRouteArgs', 'TransportManagementVpnFeatureIpv4StaticRouteArgsDict']]]] ipv4_static_routes: IPv4 Static Route
        :param pulumi.Input[Sequence[pulumi.Input[Union['TransportManagementVpnFeatureIpv6StaticRouteArgs', 'TransportManagementVpnFeatureIpv6StaticRouteArgsDict']]]] ipv6_static_routes: IPv6 Static Route
        :param pulumi.Input[str] name: The name of the Feature
        :param pulumi.Input[str] primary_dns_address_ipv4: Primary DNS Address (IPv4)
        :param pulumi.Input[str] primary_dns_address_ipv4_variable: Variable name
        :param pulumi.Input[str] primary_dns_address_ipv6: Primary DNS Address (IPv6)
        :param pulumi.Input[str] primary_dns_address_ipv6_variable: Variable name
        :param pulumi.Input[str] secondary_dns_address_ipv4: Secondary DNS Address (IPv4)
        :param pulumi.Input[str] secondary_dns_address_ipv4_variable: Variable name
        :param pulumi.Input[str] secondary_dns_address_ipv6: Secondary DNS Address (IPv6)
        :param pulumi.Input[str] secondary_dns_address_ipv6_variable: Variable name
        :param pulumi.Input[str] vpn_description: Name
        :param pulumi.Input[str] vpn_description_variable: Variable name
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[TransportManagementVpnFeatureArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource can manage a Transport Management VPN Feature.
          - Minimum SD-WAN Manager version: `20.12.0`

        ## Import

        Expected import identifier with the format: "transport_management_vpn_feature_id,feature_profile_id"

        ```sh
        $ pulumi import sdwan:index/transportManagementVpnFeature:TransportManagementVpnFeature example "f6b2c44c-693c-4763-b010-895aa3d236bd,f6dd22c8-0b4f-496c-9a0b-6813d1f8b8ac"
        ```

        :param str resource_name: The name of the resource.
        :param TransportManagementVpnFeatureArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(TransportManagementVpnFeatureArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 feature_profile_id: Optional[pulumi.Input[str]] = None,
                 ipv4_static_routes: Optional[pulumi.Input[Sequence[pulumi.Input[Union['TransportManagementVpnFeatureIpv4StaticRouteArgs', 'TransportManagementVpnFeatureIpv4StaticRouteArgsDict']]]]] = None,
                 ipv6_static_routes: Optional[pulumi.Input[Sequence[pulumi.Input[Union['TransportManagementVpnFeatureIpv6StaticRouteArgs', 'TransportManagementVpnFeatureIpv6StaticRouteArgsDict']]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 new_host_mappings: Optional[pulumi.Input[Sequence[pulumi.Input[Union['TransportManagementVpnFeatureNewHostMappingArgs', 'TransportManagementVpnFeatureNewHostMappingArgsDict']]]]] = None,
                 primary_dns_address_ipv4: Optional[pulumi.Input[str]] = None,
                 primary_dns_address_ipv4_variable: Optional[pulumi.Input[str]] = None,
                 primary_dns_address_ipv6: Optional[pulumi.Input[str]] = None,
                 primary_dns_address_ipv6_variable: Optional[pulumi.Input[str]] = None,
                 secondary_dns_address_ipv4: Optional[pulumi.Input[str]] = None,
                 secondary_dns_address_ipv4_variable: Optional[pulumi.Input[str]] = None,
                 secondary_dns_address_ipv6: Optional[pulumi.Input[str]] = None,
                 secondary_dns_address_ipv6_variable: Optional[pulumi.Input[str]] = None,
                 vpn_description: Optional[pulumi.Input[str]] = None,
                 vpn_description_variable: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = TransportManagementVpnFeatureArgs.__new__(TransportManagementVpnFeatureArgs)

            __props__.__dict__["description"] = description
            __props__.__dict__["feature_profile_id"] = feature_profile_id
            __props__.__dict__["ipv4_static_routes"] = ipv4_static_routes
            __props__.__dict__["ipv6_static_routes"] = ipv6_static_routes
            __props__.__dict__["name"] = name
            __props__.__dict__["new_host_mappings"] = new_host_mappings
            __props__.__dict__["primary_dns_address_ipv4"] = primary_dns_address_ipv4
            __props__.__dict__["primary_dns_address_ipv4_variable"] = primary_dns_address_ipv4_variable
            __props__.__dict__["primary_dns_address_ipv6"] = primary_dns_address_ipv6
            __props__.__dict__["primary_dns_address_ipv6_variable"] = primary_dns_address_ipv6_variable
            __props__.__dict__["secondary_dns_address_ipv4"] = secondary_dns_address_ipv4
            __props__.__dict__["secondary_dns_address_ipv4_variable"] = secondary_dns_address_ipv4_variable
            __props__.__dict__["secondary_dns_address_ipv6"] = secondary_dns_address_ipv6
            __props__.__dict__["secondary_dns_address_ipv6_variable"] = secondary_dns_address_ipv6_variable
            __props__.__dict__["vpn_description"] = vpn_description
            __props__.__dict__["vpn_description_variable"] = vpn_description_variable
            __props__.__dict__["version"] = None
        super(TransportManagementVpnFeature, __self__).__init__(
            'sdwan:index/transportManagementVpnFeature:TransportManagementVpnFeature',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            description: Optional[pulumi.Input[str]] = None,
            feature_profile_id: Optional[pulumi.Input[str]] = None,
            ipv4_static_routes: Optional[pulumi.Input[Sequence[pulumi.Input[Union['TransportManagementVpnFeatureIpv4StaticRouteArgs', 'TransportManagementVpnFeatureIpv4StaticRouteArgsDict']]]]] = None,
            ipv6_static_routes: Optional[pulumi.Input[Sequence[pulumi.Input[Union['TransportManagementVpnFeatureIpv6StaticRouteArgs', 'TransportManagementVpnFeatureIpv6StaticRouteArgsDict']]]]] = None,
            name: Optional[pulumi.Input[str]] = None,
            new_host_mappings: Optional[pulumi.Input[Sequence[pulumi.Input[Union['TransportManagementVpnFeatureNewHostMappingArgs', 'TransportManagementVpnFeatureNewHostMappingArgsDict']]]]] = None,
            primary_dns_address_ipv4: Optional[pulumi.Input[str]] = None,
            primary_dns_address_ipv4_variable: Optional[pulumi.Input[str]] = None,
            primary_dns_address_ipv6: Optional[pulumi.Input[str]] = None,
            primary_dns_address_ipv6_variable: Optional[pulumi.Input[str]] = None,
            secondary_dns_address_ipv4: Optional[pulumi.Input[str]] = None,
            secondary_dns_address_ipv4_variable: Optional[pulumi.Input[str]] = None,
            secondary_dns_address_ipv6: Optional[pulumi.Input[str]] = None,
            secondary_dns_address_ipv6_variable: Optional[pulumi.Input[str]] = None,
            version: Optional[pulumi.Input[int]] = None,
            vpn_description: Optional[pulumi.Input[str]] = None,
            vpn_description_variable: Optional[pulumi.Input[str]] = None) -> 'TransportManagementVpnFeature':
        """
        Get an existing TransportManagementVpnFeature resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: The description of the Feature
        :param pulumi.Input[str] feature_profile_id: Feature Profile ID
        :param pulumi.Input[Sequence[pulumi.Input[Union['TransportManagementVpnFeatureIpv4StaticRouteArgs', 'TransportManagementVpnFeatureIpv4StaticRouteArgsDict']]]] ipv4_static_routes: IPv4 Static Route
        :param pulumi.Input[Sequence[pulumi.Input[Union['TransportManagementVpnFeatureIpv6StaticRouteArgs', 'TransportManagementVpnFeatureIpv6StaticRouteArgsDict']]]] ipv6_static_routes: IPv6 Static Route
        :param pulumi.Input[str] name: The name of the Feature
        :param pulumi.Input[str] primary_dns_address_ipv4: Primary DNS Address (IPv4)
        :param pulumi.Input[str] primary_dns_address_ipv4_variable: Variable name
        :param pulumi.Input[str] primary_dns_address_ipv6: Primary DNS Address (IPv6)
        :param pulumi.Input[str] primary_dns_address_ipv6_variable: Variable name
        :param pulumi.Input[str] secondary_dns_address_ipv4: Secondary DNS Address (IPv4)
        :param pulumi.Input[str] secondary_dns_address_ipv4_variable: Variable name
        :param pulumi.Input[str] secondary_dns_address_ipv6: Secondary DNS Address (IPv6)
        :param pulumi.Input[str] secondary_dns_address_ipv6_variable: Variable name
        :param pulumi.Input[int] version: The version of the Feature
        :param pulumi.Input[str] vpn_description: Name
        :param pulumi.Input[str] vpn_description_variable: Variable name
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _TransportManagementVpnFeatureState.__new__(_TransportManagementVpnFeatureState)

        __props__.__dict__["description"] = description
        __props__.__dict__["feature_profile_id"] = feature_profile_id
        __props__.__dict__["ipv4_static_routes"] = ipv4_static_routes
        __props__.__dict__["ipv6_static_routes"] = ipv6_static_routes
        __props__.__dict__["name"] = name
        __props__.__dict__["new_host_mappings"] = new_host_mappings
        __props__.__dict__["primary_dns_address_ipv4"] = primary_dns_address_ipv4
        __props__.__dict__["primary_dns_address_ipv4_variable"] = primary_dns_address_ipv4_variable
        __props__.__dict__["primary_dns_address_ipv6"] = primary_dns_address_ipv6
        __props__.__dict__["primary_dns_address_ipv6_variable"] = primary_dns_address_ipv6_variable
        __props__.__dict__["secondary_dns_address_ipv4"] = secondary_dns_address_ipv4
        __props__.__dict__["secondary_dns_address_ipv4_variable"] = secondary_dns_address_ipv4_variable
        __props__.__dict__["secondary_dns_address_ipv6"] = secondary_dns_address_ipv6
        __props__.__dict__["secondary_dns_address_ipv6_variable"] = secondary_dns_address_ipv6_variable
        __props__.__dict__["version"] = version
        __props__.__dict__["vpn_description"] = vpn_description
        __props__.__dict__["vpn_description_variable"] = vpn_description_variable
        return TransportManagementVpnFeature(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        The description of the Feature
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="featureProfileId")
    def feature_profile_id(self) -> pulumi.Output[Optional[str]]:
        """
        Feature Profile ID
        """
        return pulumi.get(self, "feature_profile_id")

    @property
    @pulumi.getter(name="ipv4StaticRoutes")
    def ipv4_static_routes(self) -> pulumi.Output[Optional[Sequence['outputs.TransportManagementVpnFeatureIpv4StaticRoute']]]:
        """
        IPv4 Static Route
        """
        return pulumi.get(self, "ipv4_static_routes")

    @property
    @pulumi.getter(name="ipv6StaticRoutes")
    def ipv6_static_routes(self) -> pulumi.Output[Optional[Sequence['outputs.TransportManagementVpnFeatureIpv6StaticRoute']]]:
        """
        IPv6 Static Route
        """
        return pulumi.get(self, "ipv6_static_routes")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the Feature
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="newHostMappings")
    def new_host_mappings(self) -> pulumi.Output[Optional[Sequence['outputs.TransportManagementVpnFeatureNewHostMapping']]]:
        return pulumi.get(self, "new_host_mappings")

    @property
    @pulumi.getter(name="primaryDnsAddressIpv4")
    def primary_dns_address_ipv4(self) -> pulumi.Output[Optional[str]]:
        """
        Primary DNS Address (IPv4)
        """
        return pulumi.get(self, "primary_dns_address_ipv4")

    @property
    @pulumi.getter(name="primaryDnsAddressIpv4Variable")
    def primary_dns_address_ipv4_variable(self) -> pulumi.Output[Optional[str]]:
        """
        Variable name
        """
        return pulumi.get(self, "primary_dns_address_ipv4_variable")

    @property
    @pulumi.getter(name="primaryDnsAddressIpv6")
    def primary_dns_address_ipv6(self) -> pulumi.Output[Optional[str]]:
        """
        Primary DNS Address (IPv6)
        """
        return pulumi.get(self, "primary_dns_address_ipv6")

    @property
    @pulumi.getter(name="primaryDnsAddressIpv6Variable")
    def primary_dns_address_ipv6_variable(self) -> pulumi.Output[Optional[str]]:
        """
        Variable name
        """
        return pulumi.get(self, "primary_dns_address_ipv6_variable")

    @property
    @pulumi.getter(name="secondaryDnsAddressIpv4")
    def secondary_dns_address_ipv4(self) -> pulumi.Output[Optional[str]]:
        """
        Secondary DNS Address (IPv4)
        """
        return pulumi.get(self, "secondary_dns_address_ipv4")

    @property
    @pulumi.getter(name="secondaryDnsAddressIpv4Variable")
    def secondary_dns_address_ipv4_variable(self) -> pulumi.Output[Optional[str]]:
        """
        Variable name
        """
        return pulumi.get(self, "secondary_dns_address_ipv4_variable")

    @property
    @pulumi.getter(name="secondaryDnsAddressIpv6")
    def secondary_dns_address_ipv6(self) -> pulumi.Output[Optional[str]]:
        """
        Secondary DNS Address (IPv6)
        """
        return pulumi.get(self, "secondary_dns_address_ipv6")

    @property
    @pulumi.getter(name="secondaryDnsAddressIpv6Variable")
    def secondary_dns_address_ipv6_variable(self) -> pulumi.Output[Optional[str]]:
        """
        Variable name
        """
        return pulumi.get(self, "secondary_dns_address_ipv6_variable")

    @property
    @pulumi.getter
    def version(self) -> pulumi.Output[int]:
        """
        The version of the Feature
        """
        return pulumi.get(self, "version")

    @property
    @pulumi.getter(name="vpnDescription")
    def vpn_description(self) -> pulumi.Output[Optional[str]]:
        """
        Name
        """
        return pulumi.get(self, "vpn_description")

    @property
    @pulumi.getter(name="vpnDescriptionVariable")
    def vpn_description_variable(self) -> pulumi.Output[Optional[str]]:
        """
        Variable name
        """
        return pulumi.get(self, "vpn_description_variable")

