# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['TransportWanVpnFeatureAssociateRoutingBgpFeatureArgs', 'TransportWanVpnFeatureAssociateRoutingBgpFeature']

@pulumi.input_type
class TransportWanVpnFeatureAssociateRoutingBgpFeatureArgs:
    def __init__(__self__, *,
                 feature_profile_id: pulumi.Input[str],
                 transport_routing_bgp_feature_id: pulumi.Input[str],
                 transport_wan_vpn_feature_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a TransportWanVpnFeatureAssociateRoutingBgpFeature resource.
        :param pulumi.Input[str] feature_profile_id: Feature Profile ID
        :param pulumi.Input[str] transport_routing_bgp_feature_id: Transport Routing BGP Feature ID
        :param pulumi.Input[str] transport_wan_vpn_feature_id: Transport WAN VPN Feature ID
        """
        pulumi.set(__self__, "feature_profile_id", feature_profile_id)
        pulumi.set(__self__, "transport_routing_bgp_feature_id", transport_routing_bgp_feature_id)
        pulumi.set(__self__, "transport_wan_vpn_feature_id", transport_wan_vpn_feature_id)

    @property
    @pulumi.getter(name="featureProfileId")
    def feature_profile_id(self) -> pulumi.Input[str]:
        """
        Feature Profile ID
        """
        return pulumi.get(self, "feature_profile_id")

    @feature_profile_id.setter
    def feature_profile_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "feature_profile_id", value)

    @property
    @pulumi.getter(name="transportRoutingBgpFeatureId")
    def transport_routing_bgp_feature_id(self) -> pulumi.Input[str]:
        """
        Transport Routing BGP Feature ID
        """
        return pulumi.get(self, "transport_routing_bgp_feature_id")

    @transport_routing_bgp_feature_id.setter
    def transport_routing_bgp_feature_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "transport_routing_bgp_feature_id", value)

    @property
    @pulumi.getter(name="transportWanVpnFeatureId")
    def transport_wan_vpn_feature_id(self) -> pulumi.Input[str]:
        """
        Transport WAN VPN Feature ID
        """
        return pulumi.get(self, "transport_wan_vpn_feature_id")

    @transport_wan_vpn_feature_id.setter
    def transport_wan_vpn_feature_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "transport_wan_vpn_feature_id", value)


@pulumi.input_type
class _TransportWanVpnFeatureAssociateRoutingBgpFeatureState:
    def __init__(__self__, *,
                 feature_profile_id: Optional[pulumi.Input[str]] = None,
                 transport_routing_bgp_feature_id: Optional[pulumi.Input[str]] = None,
                 transport_wan_vpn_feature_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering TransportWanVpnFeatureAssociateRoutingBgpFeature resources.
        :param pulumi.Input[str] feature_profile_id: Feature Profile ID
        :param pulumi.Input[str] transport_routing_bgp_feature_id: Transport Routing BGP Feature ID
        :param pulumi.Input[str] transport_wan_vpn_feature_id: Transport WAN VPN Feature ID
        """
        if feature_profile_id is not None:
            pulumi.set(__self__, "feature_profile_id", feature_profile_id)
        if transport_routing_bgp_feature_id is not None:
            pulumi.set(__self__, "transport_routing_bgp_feature_id", transport_routing_bgp_feature_id)
        if transport_wan_vpn_feature_id is not None:
            pulumi.set(__self__, "transport_wan_vpn_feature_id", transport_wan_vpn_feature_id)

    @property
    @pulumi.getter(name="featureProfileId")
    def feature_profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        Feature Profile ID
        """
        return pulumi.get(self, "feature_profile_id")

    @feature_profile_id.setter
    def feature_profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "feature_profile_id", value)

    @property
    @pulumi.getter(name="transportRoutingBgpFeatureId")
    def transport_routing_bgp_feature_id(self) -> Optional[pulumi.Input[str]]:
        """
        Transport Routing BGP Feature ID
        """
        return pulumi.get(self, "transport_routing_bgp_feature_id")

    @transport_routing_bgp_feature_id.setter
    def transport_routing_bgp_feature_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "transport_routing_bgp_feature_id", value)

    @property
    @pulumi.getter(name="transportWanVpnFeatureId")
    def transport_wan_vpn_feature_id(self) -> Optional[pulumi.Input[str]]:
        """
        Transport WAN VPN Feature ID
        """
        return pulumi.get(self, "transport_wan_vpn_feature_id")

    @transport_wan_vpn_feature_id.setter
    def transport_wan_vpn_feature_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "transport_wan_vpn_feature_id", value)


class TransportWanVpnFeatureAssociateRoutingBgpFeature(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 feature_profile_id: Optional[pulumi.Input[str]] = None,
                 transport_routing_bgp_feature_id: Optional[pulumi.Input[str]] = None,
                 transport_wan_vpn_feature_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        This resource can manage a Transport WAN VPN Feature Associate Routing BGP Feature .
          - Minimum SD-WAN Manager version: `20.12.0`

        ## Example Usage

        ```python
        import pulumi
        import pulumi_sdwan as sdwan

        example = sdwan.TransportWanVpnFeatureAssociateRoutingBgpFeature("example",
            feature_profile_id="f6dd22c8-0b4f-496c-9a0b-6813d1f8b8ac",
            transport_wan_vpn_feature_id="140331f6-5418-4755-a059-13c77eb96037",
            transport_routing_bgp_feature_id="140331f6-5418-4755-a059-13c77eb96037")
        ```

        ## Import

        ```sh
        $ pulumi import sdwan:index/transportWanVpnFeatureAssociateRoutingBgpFeature:TransportWanVpnFeatureAssociateRoutingBgpFeature example "f6b2c44c-693c-4763-b010-895aa3d236bd"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] feature_profile_id: Feature Profile ID
        :param pulumi.Input[str] transport_routing_bgp_feature_id: Transport Routing BGP Feature ID
        :param pulumi.Input[str] transport_wan_vpn_feature_id: Transport WAN VPN Feature ID
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: TransportWanVpnFeatureAssociateRoutingBgpFeatureArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource can manage a Transport WAN VPN Feature Associate Routing BGP Feature .
          - Minimum SD-WAN Manager version: `20.12.0`

        ## Example Usage

        ```python
        import pulumi
        import pulumi_sdwan as sdwan

        example = sdwan.TransportWanVpnFeatureAssociateRoutingBgpFeature("example",
            feature_profile_id="f6dd22c8-0b4f-496c-9a0b-6813d1f8b8ac",
            transport_wan_vpn_feature_id="140331f6-5418-4755-a059-13c77eb96037",
            transport_routing_bgp_feature_id="140331f6-5418-4755-a059-13c77eb96037")
        ```

        ## Import

        ```sh
        $ pulumi import sdwan:index/transportWanVpnFeatureAssociateRoutingBgpFeature:TransportWanVpnFeatureAssociateRoutingBgpFeature example "f6b2c44c-693c-4763-b010-895aa3d236bd"
        ```

        :param str resource_name: The name of the resource.
        :param TransportWanVpnFeatureAssociateRoutingBgpFeatureArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(TransportWanVpnFeatureAssociateRoutingBgpFeatureArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 feature_profile_id: Optional[pulumi.Input[str]] = None,
                 transport_routing_bgp_feature_id: Optional[pulumi.Input[str]] = None,
                 transport_wan_vpn_feature_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = TransportWanVpnFeatureAssociateRoutingBgpFeatureArgs.__new__(TransportWanVpnFeatureAssociateRoutingBgpFeatureArgs)

            if feature_profile_id is None and not opts.urn:
                raise TypeError("Missing required property 'feature_profile_id'")
            __props__.__dict__["feature_profile_id"] = feature_profile_id
            if transport_routing_bgp_feature_id is None and not opts.urn:
                raise TypeError("Missing required property 'transport_routing_bgp_feature_id'")
            __props__.__dict__["transport_routing_bgp_feature_id"] = transport_routing_bgp_feature_id
            if transport_wan_vpn_feature_id is None and not opts.urn:
                raise TypeError("Missing required property 'transport_wan_vpn_feature_id'")
            __props__.__dict__["transport_wan_vpn_feature_id"] = transport_wan_vpn_feature_id
        super(TransportWanVpnFeatureAssociateRoutingBgpFeature, __self__).__init__(
            'sdwan:index/transportWanVpnFeatureAssociateRoutingBgpFeature:TransportWanVpnFeatureAssociateRoutingBgpFeature',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            feature_profile_id: Optional[pulumi.Input[str]] = None,
            transport_routing_bgp_feature_id: Optional[pulumi.Input[str]] = None,
            transport_wan_vpn_feature_id: Optional[pulumi.Input[str]] = None) -> 'TransportWanVpnFeatureAssociateRoutingBgpFeature':
        """
        Get an existing TransportWanVpnFeatureAssociateRoutingBgpFeature resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] feature_profile_id: Feature Profile ID
        :param pulumi.Input[str] transport_routing_bgp_feature_id: Transport Routing BGP Feature ID
        :param pulumi.Input[str] transport_wan_vpn_feature_id: Transport WAN VPN Feature ID
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _TransportWanVpnFeatureAssociateRoutingBgpFeatureState.__new__(_TransportWanVpnFeatureAssociateRoutingBgpFeatureState)

        __props__.__dict__["feature_profile_id"] = feature_profile_id
        __props__.__dict__["transport_routing_bgp_feature_id"] = transport_routing_bgp_feature_id
        __props__.__dict__["transport_wan_vpn_feature_id"] = transport_wan_vpn_feature_id
        return TransportWanVpnFeatureAssociateRoutingBgpFeature(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="featureProfileId")
    def feature_profile_id(self) -> pulumi.Output[str]:
        """
        Feature Profile ID
        """
        return pulumi.get(self, "feature_profile_id")

    @property
    @pulumi.getter(name="transportRoutingBgpFeatureId")
    def transport_routing_bgp_feature_id(self) -> pulumi.Output[str]:
        """
        Transport Routing BGP Feature ID
        """
        return pulumi.get(self, "transport_routing_bgp_feature_id")

    @property
    @pulumi.getter(name="transportWanVpnFeatureId")
    def transport_wan_vpn_feature_id(self) -> pulumi.Output[str]:
        """
        Transport WAN VPN Feature ID
        """
        return pulumi.get(self, "transport_wan_vpn_feature_id")

